program uzd2_9;

uses Crt;

type sar = ^elem;
     elem = record
       inf : real;
       kitas : sar;
     end;

///////////////////////////////////////////////////////////////////////////////
procedure Sudaryti(var sarasas : sar; elementas : real);
var pag_sar : sar;
begin
  if sarasas = nil then begin
    New(sarasas);
    sarasas^.inf := elementas;
    sarasas^.kitas := nil;
  end
  else begin
    pag_sar := sarasas;
    while pag_sar^.kitas <> nil do
      pag_sar := pag_sar^.kitas;
    New(pag_sar^.kitas);
    pag_sar^.kitas^.inf := elementas;
    pag_sar^.kitas^.kitas := nil;
  end;
end;
////////////////////////////////////////////////////////////////////////////////
procedure Spausdinti(sarasas : sar);
var pag_sar : sar;
    i : integer;
begin
  ClrScr;
  Writeln('Sarasas:');
  Writeln;
  pag_sar := sarasas;
  i := 0;
  while pag_sar <> nil do begin
    i := i + 1;
    Writeln(i, '. ', pag_sar^.inf:2:2);
    pag_sar := pag_sar^.kitas;
  end;
  Readln;
end;

/////////////////////////////////////////////////////////////////////////////////
procedure Rusiuoti(var sarasas : sar; ilgis, parametras : integer);
var i, j, t : integer;
    pag_sarasas : sar;
    skaicius : real;
begin
  ClrScr;
  if ilgis < 2 then Writeln('Sarasas tuscias! Neymanoma rusiuoti!')
  else begin
    for t := 1 to ilgis-1 do
      for i := 1 to ilgis-1 do begin
        pag_sarasas := sarasas;
        for j := 1 to ilgis-i do begin
          if parametras = 1 then

            if pag_sarasas^.inf > pag_sarasas^.kitas^.inf then begin
              skaicius := pag_sarasas^.inf;
              pag_sarasas^.inf := pag_sarasas^.kitas^.inf;
              pag_sarasas^.kitas^.inf := skaicius;
            end;
          if parametras = 2 then

            if pag_sarasas^.inf < pag_sarasas^.kitas^.inf then begin
              skaicius := pag_sarasas^.inf;
              pag_sarasas^.inf := pag_sarasas^.kitas^.inf;
              pag_sarasas^.kitas^.inf := skaicius;
            end;
          pag_sarasas := pag_sarasas^.kitas;
        end;
    end;
    Write('Sarasas surusiuotas!');
  end;
  Readln;
end;

////////////////////////////////////////////////////////////////////////////////
procedure Iterpti(var sarasas : sar; var ilgis : integer);
var pag_sarasas, pag_sarasas2 : sar;
    param, zyme, i, klaida : integer;

    reiksme : real;
begin
  if ilgis > 0 then begin

      ClrScr;
      Writeln('Pasirinkite iterpimo buda:');
      Writeln;
      Writeln('1.Pries nurodyta elementa');
      Writeln('2.Po nurodyto elemento');
      Writeln;
      repeat
      Write('Jusu pasirinkimas: ');
      {$I-}
      Readln(param);
      {$I+}
      klaida:=IOResult;
        if (klaida <> 0) or (param < 1) or (param > 2) then begin write('***Klaida: reikia ivesti skaiciu (1 arba 2)!'); writeln(); end;
        until (klaida = 0) and (param >= 1) and (param <= 2);

    ClrScr;
    repeat
    Write('Iveskite pries kuri/po kurio elem. norite iterpti: ');
    {$I-}
    Readln(zyme);
    {$I+}
    klaida:=IOResult;
        if (klaida <> 0) or (zyme < 1) or (zyme > ilgis) then begin Writeln('Klaida! Galima rusiuoti tik intervale: [1; ',ilgis, ']!'); writeln(); end;
        until (klaida = 0) and (zyme >= 1) and (zyme <= ilgis);
  end
  else begin
    zyme := 1;
    param := 1;
    ClrScr;
  end;
  Write('Iveskite elemento reiksme: ');

  {$I-}
  Readln(reiksme);
  {$I+}
  While IOResult <> 0 do begin
    Writeln('Klaida!!!!!!!!!!!!!!!!!');
    Write('Iveskite elemento reiksme: ');
      {$I-}
    Readln(reiksme);
    {$I+}
    end;

  if (zyme = 1) and (param = 1) then begin
    New(pag_sarasas);
    pag_sarasas^.inf := reiksme;
    pag_sarasas^.kitas := sarasas;
    sarasas := pag_sarasas;
  end
  else begin
    pag_sarasas := sarasas;
    if param = 1 then
      for i := 1 to zyme-2 do
        pag_sarasas := pag_sarasas^.kitas
    else
      for i := 1 to zyme-1 do
        pag_sarasas := pag_sarasas^.kitas;
    New(pag_sarasas2);
    pag_sarasas2^ := pag_sarasas^;
    pag_sarasas2^.inf := reiksme;
    pag_sarasas^.kitas := pag_sarasas2;
  end;
  Writeln('Elementas iterptas!');
  ilgis := ilgis + 1;
  Readln;
end;

////////////////////////////////////////////////////////////////////////////////
procedure Pakeisti(var sarasas : sar; ilgis : integer);
var kuri_keisti, i, klaida : integer;
    pag_sarasas : sar;
    keitinys : real;
begin
  ClrScr;
  if ilgis = 0 then Writeln('Sarasas tuscias! Elementu reiksmiu keisti negalima!')
  else begin

  repeat
    Write('Kurio elemento reiksme norite pakeisti? ');
    {$I-}
    Readln(kuri_keisti);
    {$I+}
     klaida:=IOResult;
        if (klaida <> 0) or (kuri_keisti < 1) or (kuri_keisti > ilgis) then begin Writeln('Klaida! Galima pakeisti tik intervale: [1; ',ilgis, ']!'); writeln(); end;
        until (klaida = 0) and (kuri_keisti >= 1) and (kuri_keisti <= ilgis);

    Write('Kokia reiksme norite keisti? ');
    {$I-}
    Readln(keitinys);
    {$I+}
    While IOResult <> 0 do begin
    Writeln('Klaida!!!!!!!!!!!!!!!!!');
    Write('Kokia reiksme norite keisti? ');
      {$I-}
    Readln(keitinys);
    {$I+}
    end;

    pag_sarasas := sarasas;
    for i := 1 to kuri_keisti-1 do
      pag_sarasas := pag_sarasas^.kitas;
    pag_sarasas^.inf := keitinys;
    Write('Reiksme pakeista!');
  end;
  Readln;
end;
////////////////////////////////////////////////////////////////////////////////
var i, kom, klaida : integer;
    sarasas : sar;
    skaicius : real;
begin

    ClrScr;
    Writeln('Iveskite saraso elementus (skaicius)!');
    Writeln('Pabaiga: "010"');

    repeat
      i := i + 1;
      Write(i, '. ');
      Readln(skaicius);
      if skaicius <> 010 then Sudaryti(sarasas, skaicius);
    until skaicius = 010;
    i := i - 1;

  repeat
    ClrScr;
    Writeln('Pasirinkite:');
    Writeln;
    Writeln('1.Spausdinti sarasa');
    Writeln('2.Rusiuoti didejimo tvarka');
    Writeln('3.Rusiuoti mazejimo tvarka');
    Writeln('4.Iterpti nauja elementa');
    Writeln('5.Pakeisti norima elementa');
    Writeln;
    Writeln('0.Uzdaryti programa');
    Writeln;

    repeat
    Write('Jusu pasirinkimas: ');
          {$I-}
    Readln(kom);
           {$I+}
      klaida:=IOResult;
      if (klaida <> 0) or (kom < 0) or (kom > 5) then begin write('***Klaida: reikia ivesti skaiciu (0-5)!'); writeln(); end;
     until (klaida = 0) and (kom >= 0) and (kom <= 5);

    case kom of
      1 : Spausdinti(sarasas);
      2 : Rusiuoti(sarasas, i, 1);
      3 : Rusiuoti(sarasas, i, 2);
      4 : Iterpti(sarasas, i);
      5 : Pakeisti(sarasas, i);
    end;
  until kom = 0;
  dispose(sarasas);
end.
